import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from '../../frame/BaseModel';

@modelOptions({
  schemaOptions: { collection: 'loginRecord' },
})
export class LoginRecord extends BaseModel {
  @prop({ required: false, index: false, zh: '用户id' })
  user_id: string;
  @prop({ required: false, index: false, zh: 'token' })
  token: string;
  @prop({ required: false, index: false, zh: '最后使用时间' })
  last_time: string;
  @prop({ required: false, index: false, zh: '过期时间' })
  expire_time: string;
  @prop({ required: false, index: false, zh: '最后使用ip' })
  last_ip: string;
}
